import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Scanner;

public class G {
	
	public static int[] FindMaxPath(int v, ArrayList<ArrayList<Integer>> graph) {
		ArrayList<Integer> l = new ArrayList<>();
		int lblock = 1;
		for (int i = 0; i < graph.get(v).size(); i++) {
			int[] x = FindMaxPath(graph.get(v).get(i), graph);
			l.add(x[0]);
			lblock = Math.max(lblock, x[1]);
		}
		if (l.size() == 0) {
			int[] ans = new int[2];
			ans[0] = 1;
			ans[1] = 1;
			return ans;
		}
		else if (l.size() == 1) {
			int[] ans = new int[2];
			ans[0] = l.get(0) + 1;
			ans[1] = lblock + 1;
			return ans;
		}
		else {
			int lmax = l.get(0);
			int lmaxIndex = 0;
			for (int i = 0; i < l.size(); i++) {
				if (l.get(i) > lmax) {
					lmax = l.get(i);
					lmaxIndex = i;
				}
			}
			int lmax2 = 0;
			if (lmaxIndex != 0) {
				lmax2 = l.get(0);
			}
			else {
				lmax2 = l.get(1);
			}
			for (int i = 0; i < l.size(); i++) {
				if ((l.get(i) > lmax2) && (i != lmaxIndex)) {
					lmax2 = l.get(i);
				}
			}
			
			int[] ans = new int[2];
			ans[0] = lmax + 1;
			ans[1] = Math.max(lblock, lmax + lmax2 + 1);
			return ans;
		}
		
	}
	
	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		int n = sc.nextInt();
		int m = sc.nextInt();
		ArrayList<ArrayList<Integer>> graph = new ArrayList<ArrayList<Integer>>();
		for (int i = 0; i < n; i++) {
			graph.add(new ArrayList<Integer>());
		}
		for (int i = 0; i < n - 1; i++){
			graph.get(sc.nextInt() - 1).add(i + 1);
		}
		
		int[] path = FindMaxPath(0, graph);
		System.out.println(Math.max(path[0], path[1]) + path[0] * 2 * (m - 1));
	}
}
